From 978401978a64c7e0dbd855bb0195da851604cf82 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Oct 04 2020 03:54:14 +0000
Subject: [PATCH 948/2232] Update documentation of Opaque and Trivial markers


---

diff --git a/src/extern_type.rs b/src/extern_type.rs
index 498a558..d5a5d67 100644
--- a/src/extern_type.rs
+++ b/src/extern_type.rs
@@ -145,15 +145,21 @@ pub unsafe trait ExternType {
 ///
 /// [trait]: ExternType#opaque-and-trivial-types
 pub mod kind {
-    /// An opaque type which can't be passed or held by value within Rust.
-    /// For example, a C++ type with a destructor, or a non-trivial move
-    /// constructor. Rust's strict move semantics mean that we can't own
-    /// these by value in Rust, but they can still be owned by a
-    /// `UniquePtr`...
+    /// An opaque type which cannot be passed or held by value within Rust.
+    ///
+    /// Rust's move semantics are such that every move is equivalent to a
+    /// memcpy. This is incompatible in general with C++'s constructor-based
+    /// move semantics, so a C++ type which has a destructor or nontrivial move
+    /// constructor must never exist by value in Rust. In CXX, such types are
+    /// called opaque C++ types.
+    ///
+    /// When passed across an FFI boundary, an opaque C++ type must be behind an
+    /// indirection such as a reference or UniquePtr.
     pub struct Opaque;
 
-    /// A type with trivial move constructors and no destructor, which
-    /// can therefore be owned and moved around in Rust code directly.
+    /// A type with trivial move constructor and no destructor, which can
+    /// therefore be owned and moved around in Rust code without requiring
+    /// indirection.
     pub struct Trivial;
 }
 

